diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/msg.h libpurple/protocols/msn/msg.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/msg.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/msg.h	2015-05-04 13:42:04.464970479 +0200
@@ -78,6 +78,7 @@
 
 	MsnMsgType type;
 
+	gboolean msnslp_message;
 	MsnSlpMessagePart *part;
 
 	char *remote_user;
@@ -136,6 +137,15 @@
 MsnMessage *msn_message_new_plain(const char *message);
 
 /**
+ * Creates a MSNSLP ack message.
+ *
+ * @param acked_msg The message to acknowledge.
+ *
+ * @return A new MSNSLP ack message.
+ */
+MsnMessage *msn_message_new_msnslp_ack(MsnMessage *acked_msg);
+
+/**
  * Creates a new message based off a command.
  *
  * @param session The MSN session.
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/msn.c libpurple/protocols/msn/msn.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/msn.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/msn.c	2015-05-04 13:42:04.468970479 +0200
@@ -539,7 +539,7 @@
 	for (l = session->user->endpoints; l; l = l->next) {
 		MsnUserEndpoint *ep = l->data;
 
-		if (ep->id[0] != '\0' && strncasecmp(ep->id + 1, session->guid, 36) == 0)
+		if (ep->id[0] != '\0' && g_ascii_strncasecmp(ep->id + 1, session->guid, 36) == 0)
 			/* Don't add myself to the list */
 			continue;
 
@@ -608,7 +608,7 @@
 		MsnUserEndpoint *ep = l->data;
 		char *user;
 
-		if (ep->id[0] != '\0' && strncasecmp(ep->id + 1, session->guid, 36) == 0)
+		if (ep->id[0] != '\0' && g_ascii_strncasecmp(ep->id + 1, session->guid, 36) == 0)
 			/* Don't kick myself */
 			continue;
 
@@ -3041,11 +3041,6 @@
 	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
 											   option);
 
-	option = purple_account_option_bool_new(_("Show custom smileys"),
-										  "custom_smileys", TRUE);
-	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
-											   option);
-
 	option = purple_account_option_bool_new(_("Allow direct connections"),
 										  "direct_connect", TRUE);
 	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/msnutils.c libpurple/protocols/msn/msnutils.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/msnutils.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/msnutils.c	2015-05-04 13:42:04.468970479 +0200
@@ -265,6 +265,12 @@
 				msg[retcount++] = '\n';
 				c += 4;
 			}
+			else if (!g_ascii_strncasecmp(c + 1, "br/>", 4))
+			{
+				msg[retcount++] = '\r';
+				msg[retcount++] = '\n';
+				c += 5;
+			}
 			else if (!g_ascii_strncasecmp(c + 1, "i>", 2))
 			{
 				if (!has_italic)
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/nexus.c libpurple/protocols/msn/nexus.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/nexus.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/nexus.c	2015-05-04 13:42:04.468970479 +0200
@@ -26,7 +26,6 @@
 #include "cipher.h"
 #include "debug.h"
 
-#include "msnutils.h"
 #include "soap.h"
 #include "nexus.h"
 #include "notification.h"
@@ -165,46 +164,42 @@
 	return out;
 }
 
-#define MSN_USER_KEY_SIZE (7*4 + 8 + 20 + 72)
 #define CRYPT_MODE_CBC 1
 #define CIPHER_TRIPLE_DES 0x6603
 #define HASH_SHA1 0x8004
 static char *
 msn_rps_encrypt(MsnNexus *nexus)
 {
-	char usr_key_base[MSN_USER_KEY_SIZE], *usr_key;
+	MsnUsrKey *usr_key;
 	const char magic1[] = "SESSION KEY HASH";
 	const char magic2[] = "SESSION KEY ENCRYPTION";
 	PurpleCipherContext *hmac;
 	size_t len;
-	guchar *hash;
+	guchar hash[20];
 	char *key1, *key2, *key3;
 	gsize key1_len;
-	const char *iv;
+	int *iv;
 	char *nonce_fixed;
 	char *cipher;
 	char *response;
 
-	usr_key = &usr_key_base[0];
-	/* Header */
-	msn_push32le(usr_key, 28);                  /* Header size */
-	msn_push32le(usr_key, CRYPT_MODE_CBC);      /* Crypt mode */
-	msn_push32le(usr_key, CIPHER_TRIPLE_DES);   /* Cipher type */
-	msn_push32le(usr_key, HASH_SHA1);           /* Hash type */
-	msn_push32le(usr_key, 8);                   /* IV size */
-	msn_push32le(usr_key, 20);                  /* Hash size */
-	msn_push32le(usr_key, 72);                  /* Cipher size */
-	/* Data */
-	iv = usr_key;
-	msn_push32le(usr_key, rand());
-	msn_push32le(usr_key, rand());
-	hash = (guchar *)usr_key;
-	usr_key += 20;  /* Remaining is cipher data */
+	usr_key = g_malloc(sizeof(MsnUsrKey));
+	usr_key->size = GUINT32_TO_LE(28);
+	usr_key->crypt_mode = GUINT32_TO_LE(CRYPT_MODE_CBC);
+	usr_key->cipher_type = GUINT32_TO_LE(CIPHER_TRIPLE_DES);
+	usr_key->hash_type = GUINT32_TO_LE(HASH_SHA1);
+	usr_key->iv_len = GUINT32_TO_LE(8);
+	usr_key->hash_len = GUINT32_TO_LE(20);
+	usr_key->cipher_len = GUINT32_TO_LE(72);
 
 	key1 = (char *)purple_base64_decode((const char *)nexus->tokens[MSN_AUTH_MESSENGER].secret, &key1_len);
 	key2 = rps_create_key(key1, key1_len, magic1, sizeof(magic1) - 1);
 	key3 = rps_create_key(key1, key1_len, magic2, sizeof(magic2) - 1);
 
+	iv = (int *)usr_key->iv;
+	iv[0] = rand();
+	iv[1] = rand();
+
 	len = strlen(nexus->nonce);
 	hmac = purple_cipher_context_new_by_name("hmac", NULL);
 	purple_cipher_context_set_option(hmac, "hash", "sha1");
@@ -217,17 +212,20 @@
 	nonce_fixed = g_malloc(len + 8);
 	memcpy(nonce_fixed, nexus->nonce, len);
 	memset(nonce_fixed + len, 0x08, 8);
-	cipher = des3_cbc(key3, iv, nonce_fixed, len + 8, FALSE);
+	cipher = des3_cbc(key3, usr_key->iv, nonce_fixed, len + 8, FALSE);
 	g_free(nonce_fixed);
 
-	memcpy(usr_key, cipher, 72);
+	memcpy(usr_key->hash, hash, 20);
+	memcpy(usr_key->cipher, cipher, 72);
 
 	g_free(key1);
 	g_free(key2);
 	g_free(key3);
 	g_free(cipher);
 
-	response = purple_base64_encode((guchar *)usr_key_base, MSN_USER_KEY_SIZE);
+	response = purple_base64_encode((guchar *)usr_key, sizeof(MsnUsrKey));
+
+	g_free(usr_key);
 
 	return response;
 }
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/nexus.h libpurple/protocols/msn/nexus.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/nexus.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/nexus.h	2015-05-04 13:42:04.468970479 +0200
@@ -28,6 +28,7 @@
 
 typedef struct _MsnNexus MsnNexus;
 typedef struct _MsnTicketToken MsnTicketToken;
+typedef struct _MsnUsrKey MsnUsrKey;
 
 /* Index into ticket_tokens in nexus.c Keep updated! */
 typedef enum
@@ -187,6 +188,21 @@
 	"</Body>"\
 "</Envelope>"
 
+struct _MsnUsrKey
+{
+	int size; /* 28. Does not count data */
+	int crypt_mode; /* CRYPT_MODE_CBC (1) */
+	int cipher_type; /* TripleDES (0x6603) */
+	int hash_type; /* SHA1 (0x8004) */
+	int iv_len;    /* 8 */
+	int hash_len;  /* 20 */
+	int cipher_len; /* 72 */
+	/* Data */
+	char iv[8];
+	char hash[20];
+	char cipher[72];
+};
+
 struct _MsnTicketToken {
 	GHashTable *token;
 	char *secret;
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/notification.c libpurple/protocols/msn/notification.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/notification.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/notification.c	2015-05-04 13:42:04.472970478 +0200
@@ -195,9 +195,6 @@
 	{
 		/* RPS authentication */
 
-		if (session->nexus)
-			msn_nexus_destroy(session->nexus);
-
 		session->nexus = msn_nexus_new(session);
 
 		session->nexus->policy = g_strdup(cmd->params[3]);
@@ -575,7 +572,6 @@
 		payload = xmlnode_to_str(adl_node, &payload_len);
 		msn_notification_post_adl(session->notification->cmdproc, payload, payload_len);
 		g_free(payload);
-		xmlnode_free(adl_node);
 	} else {
 		purple_debug_error("msn",
 		                   "Got FQY update for unknown user %s on network %d.\n",
@@ -1592,7 +1588,7 @@
 		/* Disconnect others, if MPOP is disabled */
 		if (is_me
 		 && !session->enable_mpop
-		 && strncasecmp(id + 1, session->guid, 36) != 0) {
+		 && g_ascii_strncasecmp(id + 1, session->guid, 36) != 0) {
 			purple_debug_info("msn", "Disconnecting Endpoint %s\n", id);
 
 			tmp = g_strdup_printf("%s;%s", user->passport, id);
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/p2p.c libpurple/protocols/msn/p2p.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/p2p.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/p2p.c	2015-05-04 13:42:04.476970478 +0200
@@ -204,43 +204,41 @@
 
 		case MSN_P2P_VERSION_TWO: {
 			MsnP2Pv2Header *header = &info->header.v2;
-			char *header_wire = NULL;
-			char *data_header_wire = NULL;
 
 			if (header->header_tlv != NULL)
-				header_wire = msn_tlvlist_write(header->header_tlv, (size_t *)&header->header_len);
+				header->header_len = msn_tlvlist_size(header->header_tlv) + 8;
 			else
-				header->header_len = 0;
+				header->header_len = 8;
 
 			if (header->data_tlv != NULL)
-				data_header_wire = msn_tlvlist_write(header->data_tlv, (size_t *)&header->data_header_len);
+				header->data_header_len = msn_tlvlist_size(header->data_tlv) + 8;
 			else
-				header->data_header_len = 0;
+				header->data_header_len = 8;
 
-			tmp = wire = g_new(char, 16 + header->header_len + header->data_header_len);
+			tmp = wire = g_new(char, header->header_len + header->data_header_len);
 
-			msn_push8(tmp, header->header_len + 8);
+			msn_push8(tmp, header->header_len);
 			msn_push8(tmp, header->opcode);
-			msn_push16be(tmp, header->data_header_len + 8 + header->message_len);
+			msn_push16be(tmp, header->data_header_len + header->message_len);
 			msn_push32be(tmp, header->base_id);
 
-			if (header_wire != NULL) {
-				memcpy(tmp, header_wire, header->header_len);
-				tmp += header->header_len;
+			if (header->header_tlv != NULL) {
+				msn_tlvlist_write(tmp, header->header_len - 8, header->header_tlv);
+				tmp += header->header_len - 8;
 			}
 
-			msn_push8(tmp, header->data_header_len + 8);
+			msn_push8(tmp, header->data_header_len);
 			msn_push8(tmp, header->data_tf);
 			msn_push16be(tmp, header->package_number);
 			msn_push32be(tmp, header->session_id);
 
-			if (data_header_wire != NULL) {
-				memcpy(tmp, data_header_wire, header->data_header_len);
-				tmp += header->data_header_len;
+			if (header->data_tlv != NULL) {
+				msn_tlvlist_write(tmp, header->data_header_len - 8, header->data_tlv);
+				tmp += header->data_header_len - 8;
 			}
 
 			if (len)
-				*len = header->header_len + header->data_header_len + 16;
+				*len = header->header_len + header->data_header_len;
 
 			break;
 		}
@@ -250,6 +248,7 @@
 	}
 
 	return wire;
+
 }
 
 size_t
@@ -313,28 +312,11 @@
 }
 
 gboolean
-msn_p2p_msg_is_data(const MsnP2PInfo *info)
+msn_p2p_msg_is_data(const MsnP2PHeaderFlag flags)
 {
-	gboolean data = FALSE;
-
-	switch (info->version) {
-		case MSN_P2P_VERSION_ONE: {
-			guint32 flags = info->header.v1.flags;
-			data = (flags == P2P_MSN_OBJ_DATA ||
-			        flags == (P2P_WLM2009_COMP | P2P_MSN_OBJ_DATA) ||
-			        flags == P2P_FILE_DATA);
-			break;
-		}
-
-		case MSN_P2P_VERSION_TWO:
-			data = info->header.v2.message_len > 0;
-			break;
-
-		default:
-			purple_debug_error("msn", "Invalid P2P Info version: %d\n", info->version);
-	}
-
-	return data;
+	return (flags == P2P_MSN_OBJ_DATA ||
+	        flags == (P2P_WLM2009_COMP | P2P_MSN_OBJ_DATA) ||
+	        flags == P2P_FILE_DATA);
 }
 
 gboolean
@@ -349,7 +331,6 @@
 
 		case MSN_P2P_VERSION_TWO:
 			/* Nothing to do! */
-			valid = TRUE;
 			break;
 
 		default:
@@ -360,28 +341,6 @@
 }
 
 gboolean
-msn_p2p_info_is_first(MsnP2PInfo *info)
-{
-	gboolean first = FALSE;
-
-	switch (info->version) {
-		case MSN_P2P_VERSION_ONE:
-			first = info->header.v1.offset == 0;
-			break;
-
-		case MSN_P2P_VERSION_TWO:
-			/* Nothing to do! */
-			first = info->header.v2.data_tf & TF_FIRST;
-			break;
-
-		default:
-			purple_debug_error("msn", "Invalid P2P Info version: %d\n", info->version);
-	}
-
-	return first;
-}
-
-gboolean
 msn_p2p_info_is_final(MsnP2PInfo *info)
 {
 	gboolean final = FALSE;
@@ -392,7 +351,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			final = msn_tlv_gettlv(info->header.v2.data_tlv, P2P_DATA_TLV_REMAINING, 1) == NULL;
+			/* Nothing to do! */
 			break;
 
 		default:
@@ -402,116 +361,6 @@
 	return final;
 }
 
-void
-msn_p2p_info_create_ack(MsnP2PInfo *old_info, MsnP2PInfo *new_info)
-{
-	switch (old_info->version) {
-		case MSN_P2P_VERSION_ONE: {
-			MsnP2PHeader *old = &old_info->header.v1;
-			MsnP2PHeader *new = &new_info->header.v1;
-
-			new->session_id = old->session_id;
-			new->flags = P2P_ACK;
-			new->ack_id = old->id;
-			new->ack_sub_id = old->ack_id;
-			new->ack_size = old->total_size;
-			break;
-		}
-
-		case MSN_P2P_VERSION_TWO: {
-			MsnP2Pv2Header *old = &old_info->header.v2;
-			MsnP2Pv2Header *new = &new_info->header.v2;
-
-			msn_tlvlist_add_32(&new->header_tlv, P2P_HEADER_TLV_TYPE_ACK, old->base_id + old->message_len);
-			new->opcode = P2P_OPCODE_NONE;
-
-			if (old->message_len > 0) {
-				if (!msn_tlv_gettlv(old->header_tlv, P2P_HEADER_TLV_TYPE_ACK, 1)) {
-					if (old->opcode & P2P_OPCODE_SYN) {
-						msn_tlv_t *ack_tlv;
-						new->opcode |= P2P_OPCODE_RAK;
-						
-						ack_tlv = msn_tlv_gettlv(old->header_tlv, P2P_HEADER_TLV_TYPE_PEER_INFO, 1);
-						if (ack_tlv) {
-							msn_tlvlist_add_tlv(&new->header_tlv, ack_tlv);
-							new->opcode |= P2P_OPCODE_SYN;
-						}
-					}
-				}
-			}
-			break;
-		}
-
-		default:
-			purple_debug_error("msn", "Invalid P2P Info version: %d\n", old_info->version);
-	}
-}
-
-gboolean
-msn_p2p_info_require_ack(MsnP2PInfo *info)
-{
-	gboolean ret = FALSE;
-
-	switch (info->version) {
-		case MSN_P2P_VERSION_ONE: {
-			guint32 flags = msn_p2p_info_get_flags(info);
-
-			ret = flags == P2P_NO_FLAG || flags == P2P_WLM2009_COMP ||
-			      msn_p2p_msg_is_data(info);
-			break;
-		}
-
-		case MSN_P2P_VERSION_TWO:
-			ret = (info->header.v2.opcode & P2P_OPCODE_RAK) > 0;
-			break;
-
-		default:
-			purple_debug_error("msn", "Invalid P2P Info version: %d\n", info->version);
-	}
-
-	return ret;
-}
-
-gboolean
-msn_p2p_info_is_ack(MsnP2PInfo *info)
-{
-	gboolean ret = FALSE;
-
-	switch (info->version) {
-		case MSN_P2P_VERSION_ONE: {
-			ret = msn_p2p_info_get_flags(info) == P2P_ACK;
-			break;
-		}
-
-		case MSN_P2P_VERSION_TWO:
-			ret = msn_tlv_gettlv(info->header.v2.header_tlv, P2P_HEADER_TLV_TYPE_ACK, 1) != NULL;
-			break;
-
-		default:
-			purple_debug_error("msn", "Invalid P2P Info version: %d\n", info->version);
-	}
-
-	return ret;
-}
-
-void
-msn_p2p_info_init_first(MsnP2PInfo *info, MsnP2PInfo *old_info)
-{
-	switch (info->version) {
-		case MSN_P2P_VERSION_ONE:
-			info->header.v1.session_id = old_info->header.v1.session_id;
-			info->header.v1.flags = old_info->header.v1.flags;
-			break;
-
-		case MSN_P2P_VERSION_TWO:
-			info->header.v2.data_tf = TF_FIRST;
-			break;
-
-		default:
-			purple_debug_error("msn", "Invalid P2P Info version: %d\n", info->version);
-	}
-}
-
 guint32
 msn_p2p_info_get_session_id(MsnP2PInfo *info)
 {
@@ -523,7 +372,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			session_id = info->header.v2.session_id;
+			/* Nothing to do! */
 			break;
 
 		default:
@@ -544,7 +393,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			id = info->header.v2.base_id;
+			/* Nothing to do! */
 			break;
 
 		default:
@@ -628,7 +477,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			flags = info->header.v2.data_tf;
+			/* Nothing to do! */
 			break;
 
 		default:
@@ -716,7 +565,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			info->header.v2.session_id = session_id;
+			/* Nothing to do! */
 			break;
 
 		default:
@@ -734,7 +583,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			info->header.v2.base_id = id;
+			/* Nothing to do! */
 			break;
 
 		default:
@@ -803,7 +652,7 @@
 			break;
 
 		case MSN_P2P_VERSION_TWO:
-			info->header.v2.data_tf = flags;
+			/* Nothing to do! */
 			break;
 
 		default:
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/p2p.h libpurple/protocols/msn/p2p.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/p2p.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/p2p.h	2015-05-04 13:42:04.476970478 +0200
@@ -59,42 +59,6 @@
 /*	guint8  body[1]; */
 } MsnP2Pv2Header;
 
-typedef struct {
-	guint16 protocol_version;
-	guint16 implementation_id;
-	guint16 version;
-	guint16 reserved;
-	guint32 caps;
-} P2PPeerInfo;
-
-typedef enum
-{
-	TF_FIRST    = 0x01,     /**< The first package. */
-	TF_MSNOBJ   = 0x04,     /**< Payload contains binary data for MsnObject. */
-	TF_FILE     = 0x06      /**< Payload contains binary data. */
-} TF;
-
-typedef enum
-{
-	P2P_HEADER_TLV_TYPE_PEER_INFO  = 0x01, /**< Client peer info */
-	P2P_HEADER_TLV_TYPE_ACK        = 0x02, /**< ACK */
-	P2P_HEADER_TLV_TYPE_NAK        = 0x03  /**< NAK */
-} P2PHeaderTLVType;
-
-typedef enum
-{
-	P2P_DATA_TLV_REMAINING  = 0x01, /**< Indicates the remaining data to transfer.*/
-} P2PDataTLVType;
-
-typedef enum
-{
-	P2P_PI_PVER     = 0x0200,
-	P2P_PI_IMP_ID   = 0,
-	P2P_PI_VER      = 0x0e00,
-	P2P_PI_RES      = 0,
-	P2P_PI_CAPS     = 0x0000010f
-} P2PPeerInfoVal;
-
 typedef struct
 {
 	guint32 value;
@@ -178,29 +142,14 @@
 msn_p2p_info_to_string(MsnP2PInfo *info, GString *str);
 
 gboolean
-msn_p2p_msg_is_data(const MsnP2PInfo *info);
+msn_p2p_msg_is_data(const MsnP2PHeaderFlag flags);
 
 gboolean
 msn_p2p_info_is_valid(MsnP2PInfo *info);
 
 gboolean
-msn_p2p_info_is_first(MsnP2PInfo *info);
-
-gboolean
 msn_p2p_info_is_final(MsnP2PInfo *info);
 
-void
-msn_p2p_info_create_ack(MsnP2PInfo *old_info, MsnP2PInfo *new_info);
-
-gboolean
-msn_p2p_info_require_ack(MsnP2PInfo *info);
-
-gboolean
-msn_p2p_info_is_ack(MsnP2PInfo *info);
-
-void
-msn_p2p_info_init_first(MsnP2PInfo *new_info, MsnP2PInfo *old_info);
-
 guint32
 msn_p2p_info_get_session_id(MsnP2PInfo *info);
 
@@ -262,3 +211,4 @@
 msn_p2p_info_set_app_id(MsnP2PInfo *info, guint32 app_id);
 
 #endif /* MSN_P2P_H */
+
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/session.c libpurple/protocols/msn/session.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/session.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/session.c	2015-05-04 13:42:04.484970478 +0200
@@ -263,10 +263,8 @@
 	{
 		swboard = msn_switchboard_new(session);
 		swboard->im_user = g_strdup(username);
-		if (msn_switchboard_request(swboard))
-			msn_switchboard_request_add_user(swboard, username);
-		else
-			return NULL;
+		msn_switchboard_request(swboard);
+		msn_switchboard_request_add_user(swboard, username);
 	}
 
 	swboard->flag |= flag;
@@ -290,8 +288,6 @@
 msn_session_activate_login_timeout(MsnSession *session)
 {
 	if (!session->logged_in && session->connected) {
-		if (session->login_timeout)
-			purple_timeout_remove(session->login_timeout);
 		session->login_timeout =
 			purple_timeout_add_seconds(MSN_LOGIN_FQY_TIMEOUT,
 			                           msn_login_timeout_cb, session);
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slp.c libpurple/protocols/msn/slp.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slp.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slp.c	2015-05-04 13:42:04.484970478 +0200
@@ -284,6 +284,7 @@
 	purple_xfer_unref(xfer);
 
 	slpmsg = msn_slpmsg_file_new(slpcall, purple_xfer_get_size(xfer));
+	msn_slpmsg_set_slplink(slpmsg, slpcall->slplink);
 
 	msn_slplink_send_slpmsg(slpcall->slplink, slpmsg);
 }
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slpcall.c libpurple/protocols/msn/slpcall.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slpcall.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slpcall.c	2015-05-04 13:42:04.484970478 +0200
@@ -237,7 +237,7 @@
 {
 	GList *smileys;
 
-	if (!purple_account_get_bool(account, "custom_smileys", TRUE))
+	if (!purple_account_get_bool(account, "custom_smileys", FALSE))
 		return NULL;
 
 	smileys = purple_smileys_get_all();
@@ -328,7 +328,7 @@
 			dc->remote_nonce[36] = '\0';
 		}
 
-		if (!strcasecmp(listening, "false")) {
+		if (!g_ascii_strcasecmp(listening, "false")) {
 			if (dc->listen_data != NULL) {
 				/*
 				 * We'll listen for incoming connections but
@@ -490,10 +490,12 @@
 		if (img != NULL) {
 			/* DATA PREP */
 			slpmsg = msn_slpmsg_dataprep_new(slpcall);
+			msn_slpmsg_set_slplink(slpmsg, slplink);
 			msn_slplink_queue_slpmsg(slplink, slpmsg);
 
 			/* DATA */
 			slpmsg = msn_slpmsg_obj_new(slpcall, img);
+			msn_slpmsg_set_slplink(slpmsg, slplink);
 			msn_slplink_queue_slpmsg(slplink, slpmsg);
 			purple_imgstore_unref(img);
 
@@ -1128,7 +1130,7 @@
 		}
 		g_free(body_str);
 	}
-	 else if (msn_p2p_msg_is_data(slpmsg->p2p_info))
+	 else if (msn_p2p_msg_is_data(flags))
 	{
 		slpcall = msn_slplink_find_slp_call_with_session_id(slplink, session_id);
 
@@ -1145,7 +1147,7 @@
 			slpcall->wasted = TRUE;
 		}
 	}
-	else if (msn_p2p_info_is_ack(slpmsg->p2p_info))
+	else if (flags == P2P_ACK)
 	{
 		/* Acknowledgement of previous message. Don't do anything currently. */
 	}
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slpcall.h libpurple/protocols/msn/slpcall.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slpcall.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slpcall.h	2015-05-04 13:42:04.484970478 +0200
@@ -65,7 +65,7 @@
 	gboolean wait_for_socket;
 
 	void (*progress_cb)(MsnSlpCall *slpcall,
-						gsize total_length, gsize len);
+						gsize total_length, gsize len, gsize offset);
 	void (*session_init_cb)(MsnSlpCall *slpcall);
 
 	/* Can be checksum, or smile */
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slplink.c libpurple/protocols/msn/slplink.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slplink.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slplink.c	2015-05-04 13:42:04.488970478 +0200
@@ -79,7 +79,6 @@
 	slplink->slp_seq_id = rand() % 0xFFFFFF00 + 4;
 
 	slplink->remote_user = g_strdup(username);
-	slplink->p2p_version = MSN_P2P_VERSION_ONE;
 
 	slplink->slp_msg_queue = g_queue_new();
 
@@ -265,12 +264,6 @@
 	return NULL;
 }
 
-MsnP2PVersion
-msn_slplink_get_p2p_version(MsnSlpLink *slplink)
-{
-	return slplink->p2p_version;
-}
-
 static void
 msn_slplink_send_part(MsnSlpLink *slplink, MsnSlpMessagePart *part)
 {
@@ -299,7 +292,7 @@
 	part = msn_slpmsgpart_new(msn_p2p_info_dup(info));
 	part->ack_data = slpmsg;
 
-	real_size = msn_p2p_info_is_ack(info) ? 0 : slpmsg->size;
+	real_size = (msn_p2p_info_get_flags(info) == P2P_ACK) ? 0 : slpmsg->size;
 
 	offset = msn_p2p_info_get_offset(info);
 	if (offset < real_size)
@@ -337,14 +330,15 @@
 	msn_slplink_send_part(slplink, part);
 
 
-	if (msn_p2p_msg_is_data(info) && slpmsg->slpcall != NULL)
+	if (msn_p2p_msg_is_data(msn_p2p_info_get_flags(info)) &&
+		(slpmsg->slpcall != NULL))
 	{
 		slpmsg->slpcall->progress = TRUE;
 
 		if (slpmsg->slpcall->progress_cb != NULL)
 		{
 			slpmsg->slpcall->progress_cb(slpmsg->slpcall, slpmsg->size,
-										 len);
+										 len, offset);
 		}
 	}
 
@@ -364,7 +358,7 @@
 	{
 		msn_p2p_info_set_ack_id(info, rand() % 0xFFFFFF00);
 	}
-	else if (msn_p2p_msg_is_data(info))
+	else if (msn_p2p_msg_is_data(flags))
 	{
 		MsnSlpCall *slpcall;
 		slpcall = slpmsg->slpcall;
@@ -412,10 +406,21 @@
 	}
 }
 
+static MsnSlpMessage *
+msn_slplink_create_ack(MsnSlpLink *slplink, MsnP2PInfo *info)
+{
+	MsnSlpMessage *slpmsg;
+
+	slpmsg = msn_slpmsg_ack_new(info);
+	msn_slpmsg_set_slplink(slpmsg, slplink);
+
+	return slpmsg;
+}
+
 static void
 msn_slplink_send_ack(MsnSlpLink *slplink, MsnP2PInfo *info)
 {
-	MsnSlpMessage *slpmsg = msn_slpmsg_ack_new(slplink, info);
+	MsnSlpMessage *slpmsg = msn_slplink_create_ack(slplink, info);
 
 	msn_slplink_send_slpmsg(slplink, slpmsg);
 	msn_slpmsg_destroy(slpmsg);
@@ -442,19 +447,22 @@
 {
 	MsnSlpMessage *slpmsg;
 	guint32 session_id;
+	guint32 flags;
 
-	slpmsg = msn_slpmsg_new(slplink, NULL);
+	slpmsg = msn_slpmsg_new(slplink);
 	slpmsg->id = msn_p2p_info_get_id(info);
 	session_id = msn_p2p_info_get_session_id(info);
+	msn_p2p_info_set_session_id(slpmsg->p2p_info, session_id);
 	slpmsg->size = msn_p2p_info_get_total_size(info);
-	msn_p2p_info_init_first(slpmsg->p2p_info, info);
+	flags = msn_p2p_info_get_flags(info);
+	msn_p2p_info_set_flags(slpmsg->p2p_info, flags);
 
 	if (session_id)
 	{
 		slpmsg->slpcall = msn_slplink_find_slp_call_with_session_id(slplink, session_id);
 		if (slpmsg->slpcall != NULL)
 		{
-			if (msn_p2p_msg_is_data(info))
+			if (msn_p2p_msg_is_data(flags))
 			{
 				PurpleXfer *xfer = slpmsg->slpcall->xfer;
 				if (xfer != NULL)
@@ -494,6 +502,7 @@
 process_complete_msg(MsnSlpLink *slplink, MsnSlpMessage *slpmsg, MsnP2PInfo *info)
 {
 	MsnSlpCall *slpcall;
+	guint32 flags;
 
 	slpcall = msn_slp_process_msg(slplink, slpmsg);
 
@@ -504,7 +513,10 @@
 
 	purple_debug_info("msn", "msn_slplink_process_msg: slpmsg complete\n");
 
-	if (msn_p2p_info_require_ack(slpmsg->p2p_info))
+	flags = msn_p2p_info_get_flags(slpmsg->p2p_info);
+
+	if (flags == P2P_NO_FLAG || flags == P2P_WLM2009_COMP ||
+	    msn_p2p_msg_is_data(flags))
 	{
 		/* Release all the messages and send the ACK */
 
@@ -517,7 +529,7 @@
 			 */
 			purple_debug_info("msn", "msn_slplink_process_msg: save ACK\n");
 
-			slpcall->slplink->dc->prev_ack = msn_slpmsg_ack_new(slplink, info);
+			slpcall->slplink->dc->prev_ack = msn_slplink_create_ack(slplink, info);
 		} else if (!slpcall->wasted) {
 			purple_debug_info("msn", "msn_slplink_process_msg: send ACK\n");
 
@@ -561,6 +573,7 @@
 {
 	MsnSlpMessage *slpmsg;
 	MsnP2PInfo *info;
+	guint64 offset;
 
 	info = part->info;
 
@@ -573,7 +586,9 @@
 		return;
 	}
 
-	if (msn_p2p_info_is_first(info))
+	offset = msn_p2p_info_get_offset(info);
+
+	if (offset == 0)
 		slpmsg = init_first_msg(slplink, info);
 	else {
 		guint32 session_id, id;
@@ -590,14 +605,15 @@
 
 	slpmsg_add_part(slpmsg, part);
 
-	if (msn_p2p_msg_is_data(slpmsg->p2p_info) && slpmsg->slpcall != NULL)
+	if (msn_p2p_msg_is_data(msn_p2p_info_get_flags(slpmsg->p2p_info)) &&
+		(slpmsg->slpcall != NULL))
 	{
 		slpmsg->slpcall->progress = TRUE;
 
 		if (slpmsg->slpcall->progress_cb != NULL)
 		{
 			slpmsg->slpcall->progress_cb(slpmsg->slpcall, slpmsg->size,
-										 part->size);
+										 part->size, offset);
 		}
 	}
 
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slplink.h libpurple/protocols/msn/slplink.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slplink.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slplink.h	2015-05-04 13:42:04.488970478 +0200
@@ -45,7 +45,6 @@
 	guint refs;
 
 	char *remote_user;
-	MsnP2PVersion p2p_version;
 
 	int slp_seq_id;
 
@@ -76,8 +75,6 @@
 MsnSlpCall *msn_slplink_find_slp_call(MsnSlpLink *slplink,
 									  const char *id);
 MsnSlpCall *msn_slplink_find_slp_call_with_session_id(MsnSlpLink *slplink, long id);
-MsnP2PVersion msn_slplink_get_p2p_version(MsnSlpLink *slplink);
-
 void msn_slplink_queue_slpmsg(MsnSlpLink *slplink, MsnSlpMessage *slpmsg);
 void msn_slplink_send_slpmsg(MsnSlpLink *slplink,
 							 MsnSlpMessage *slpmsg);
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slpmsg.c libpurple/protocols/msn/slpmsg.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slpmsg.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slpmsg.c	2015-05-04 13:42:04.488970478 +0200
@@ -34,23 +34,21 @@
  **************************************************************************/
 
 MsnSlpMessage *
-msn_slpmsg_new(MsnSlpLink *slplink, MsnSlpCall *slpcall)
+msn_slpmsg_new(MsnSlpLink *slplink)
 {
 	MsnSlpMessage *slpmsg;
-	MsnP2PVersion p2p;
-
-	g_return_val_if_fail(slplink != NULL, NULL);
 
 	slpmsg = g_new0(MsnSlpMessage, 1);
 
 	if (purple_debug_is_verbose())
 		purple_debug_info("msn", "slpmsg new (%p)\n", slpmsg);
 
-	msn_slpmsg_set_slplink(slpmsg, slplink);
-	slpmsg->slpcall = slpcall;
+	if (slplink)
+		msn_slpmsg_set_slplink(slpmsg, slplink);
+	else
+		slpmsg->slplink = NULL;
 
-	p2p = msn_slplink_get_p2p_version(slplink);
-	slpmsg->p2p_info = msn_p2p_info_new(p2p);
+	slpmsg->p2p_info = msn_p2p_info_new(MSN_P2P_VERSION_ONE);
 
 	return slpmsg;
 }
@@ -105,6 +103,7 @@
 
 	slplink->slp_msgs =
 		g_list_append(slplink->slp_msgs, slpmsg);
+
 }
 
 void
@@ -189,24 +188,30 @@
 		g_strlcat(body, content, body_len);
 	}
 
-	slpmsg = msn_slpmsg_new(slplink, slpcall);
+	slpmsg = msn_slpmsg_new(slplink);
 	msn_slpmsg_set_body(slpmsg, body, body_len);
 
+	slpmsg->slpcall = slpcall;
+
 	g_free(body);
 
 	return slpmsg;
 }
 
-MsnSlpMessage *msn_slpmsg_ack_new(MsnSlpLink *slplink, MsnP2PInfo *ack_info)
+MsnSlpMessage *msn_slpmsg_ack_new(MsnP2PInfo *ack_info)
 {
 	MsnSlpMessage *slpmsg;
 	MsnP2PInfo *new_info;
 
-	slpmsg = msn_slpmsg_new(slplink, NULL);
+	slpmsg = msn_slpmsg_new(NULL);
 
 	new_info = slpmsg->p2p_info;
-	msn_p2p_info_create_ack(ack_info, new_info);
+	msn_p2p_info_set_session_id(new_info, msn_p2p_info_get_session_id(ack_info));
 	slpmsg->size = msn_p2p_info_get_total_size(ack_info);
+	msn_p2p_info_set_flags(new_info, P2P_ACK);
+	msn_p2p_info_set_ack_id(new_info, msn_p2p_info_get_id(ack_info));
+	msn_p2p_info_set_ack_sub_id(new_info, msn_p2p_info_get_ack_id(ack_info));
+	msn_p2p_info_set_ack_size(new_info, msn_p2p_info_get_total_size(ack_info));
 	slpmsg->info = "SLP ACK";
 
 	return slpmsg;
@@ -216,7 +221,8 @@
 {
 	MsnSlpMessage *slpmsg;
 
-	slpmsg = msn_slpmsg_new(slpcall->slplink, slpcall);
+	slpmsg = msn_slpmsg_new(NULL);
+	slpmsg->slpcall = slpcall;
 	msn_p2p_info_set_flags(slpmsg->p2p_info, P2P_MSN_OBJ_DATA);
 	slpmsg->info = "SLP DATA";
 
@@ -229,8 +235,9 @@
 {
 	MsnSlpMessage *slpmsg;
 
-	slpmsg = msn_slpmsg_new(slpcall->slplink, slpcall);
+	slpmsg = msn_slpmsg_new(NULL);
 
+	slpmsg->slpcall = slpcall;
 	msn_p2p_info_set_session_id(slpmsg->p2p_info, slpcall->session_id);
 	msn_slpmsg_set_body(slpmsg, NULL, 4);
 	slpmsg->info = "SLP DATA PREP";
@@ -243,8 +250,9 @@
 {
 	MsnSlpMessage *slpmsg;
 
-	slpmsg = msn_slpmsg_new(slpcall->slplink, slpcall);
+	slpmsg = msn_slpmsg_new(NULL);
 
+	slpmsg->slpcall = slpcall;
 	msn_p2p_info_set_flags(slpmsg->p2p_info, P2P_FILE_DATA);
 	slpmsg->info = "SLP FILE";
 	slpmsg->size = size;
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slpmsg.h libpurple/protocols/msn/slpmsg.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slpmsg.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slpmsg.h	2015-05-04 13:42:04.488970478 +0200
@@ -72,7 +72,7 @@
  * If it's set to NULL, it is a temporary SlpMessage.
  * @return The created slp message.
  */
-MsnSlpMessage *msn_slpmsg_new(MsnSlpLink *slplink, MsnSlpCall *slpcall);
+MsnSlpMessage *msn_slpmsg_new(MsnSlpLink *slplink);
 
 /**
  * Destroys a slp message
@@ -104,7 +104,7 @@
  *
  * @return A new SlpMessage with ACK headers
  */
-MsnSlpMessage *msn_slpmsg_ack_new(MsnSlpLink *slplink, MsnP2PInfo *info);
+MsnSlpMessage *msn_slpmsg_ack_new(MsnP2PInfo *info);
 
 /**
  * Create a new SLP message for MsnObject data.
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/slpmsg_part.c libpurple/protocols/msn/slpmsg_part.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/slpmsg_part.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/slpmsg_part.c	2015-05-04 13:42:04.488970478 +0200
@@ -42,15 +42,14 @@
 	return msn_slpmsgpart_ref(part);
 }
 
-MsnSlpMessagePart *
-msn_slpmsgpart_new_from_data(MsnP2PVersion p2p, const char *data, size_t data_len)
+MsnSlpMessagePart *msn_slpmsgpart_new_from_data(const char *data, size_t data_len)
 {
 	MsnSlpMessagePart *part;
 	MsnP2PInfo *info;
 	size_t len;
 	int body_len;
 
-	info = msn_p2p_info_new(p2p);
+	info = msn_p2p_info_new(MSN_P2P_VERSION_ONE);
 
 	/* Extract the binary SLP header */
 	len = msn_p2p_header_from_wire(info, data, data_len);
@@ -176,7 +175,7 @@
 
 	slpmsg = data;
 
-	real_size = msn_p2p_info_is_ack(slpmsg->p2p_info) ? 0 : slpmsg->size;
+	real_size = (msn_p2p_info_get_flags(slpmsg->p2p_info) == P2P_ACK) ? 0 : slpmsg->size;
 
 	offset = msn_p2p_info_get_offset(slpmsg->p2p_info);
 	offset += msn_p2p_info_get_length(part->info);
@@ -198,7 +197,7 @@
 	else
 	{
 		/* The whole message has been sent */
-		if (msn_p2p_msg_is_data(slpmsg->p2p_info))
+		if (msn_p2p_msg_is_data(msn_p2p_info_get_flags(slpmsg->p2p_info)))
 		{
 			if (slpmsg->slpcall != NULL)
 			{
